// defining global variables

const IS_DEBUG = false; //true for developing the getPagesSource js.

if (IS_DEBUG) {
  var GET_PAGE_FILE = "js/getPagesSource.js";   //For development
} else {
  var GET_PAGE_FILE = "jsm/getPagesSource.min.js"; //For production
}

var tabId = -100;
var isSpeaking = false; //Can only be changed by pause/play button click or by finishing the whole text
var isRecording = false;
var caretPos = 0;
var wholeText = "";
var msg = new SpeechSynthesisUtterance('hello world');
var LicenseStatusFromBackground = "Unused";
var bg;
chrome.runtime.getBackgroundPage(function(backgroundWindow) {
    onBgLoad(backgroundWindow);
});
msg.volume = 1; // 0 to 1
msg.rate = 0.9; // 0.1 to 10
msg.pitch = 1; //0 to 2
msg.lang = select_language.value;
isUnderProgramaticChange = false;



document.getElementById("speak_button").addEventListener("click", startOrPause);
document.getElementById("clear_button").addEventListener("click", clearText);
document.getElementById("reset_button").addEventListener("click", goToBeginning);
document.getElementById("reload_button").addEventListener("click", reloadText);
//document.getElementById("record_button").addEventListener("click",recordOrStoprecord);
document.getElementById("readability_button").addEventListener("click", toggleReadability);
document.getElementById("purchasedisplaybutton").addEventListener("click", openpurchaseWindow);
document.getElementById("launchpremiumbutton").addEventListener("click",openpurchaseWindow);
document.getElementById("infoicon").addEventListener("click",openhelpWindow);
document.getElementById("boxclose").addEventListener("click",hidepurchaseoverlay);




document.getElementById("select_language").addEventListener("change",updateLanguage);
document.getElementById("select_speed").addEventListener("change",updateSpeed);
document.getElementById("text_box").addEventListener("keyup", retainText);

navigatorState();

function navigatorState() {
    //console.log("the system online state is " + navigator.onLine);

    var txt = "";
    txt += "Browser CodeName: " + navigator.appCodeName +"-";
    txt += " Browser Name: " + navigator.appName +"-";
    txt += " Browser Version: " + navigator.appVersion +"-" ;
    txt += " Cookies Enabled: " + navigator.cookieEnabled +"-";
    txt += " Browser Language: " + navigator.language +"-";
    txt += " Browser Online: " + navigator.onLine+"-" ;
    txt += " Platform: " + navigator.platform +"-";
    txt += " User-agent header: " + navigator.userAgent+"-";

   // document.getElementById("demo").innerHTML = txt;
  //  console.log(txt);
}

function openhelpWindow(){
  /*  var popupWindow = window.open(
        chrome.runtime.getURL("../html/ttsreaderxhelp.html"),
        "purchaseDialog",
        "width=600,height=600"
    );*/
    var newURL = "../html/ttsreaderxhelp.html";
    chrome.tabs.create({ url: newURL });
}

// define a handler
function doc_keyUp(e) {

   /* if (e.ctrlKey && e.keyCode == 39) {  // ctrl + right arrow key - play
        // call your function to do the thing
        //play();
        reloadText();
    }
    if (e.ctrlKey && e.keyCode == 37) { // ctrl + left arrow key - pause
        // call your function to do the thing
       goToBeginning();
    }
    if (e.ctrlKey && e.keyCode == 38) {  // ctrl + up arrow key - clear text
        // call your function to do the thing
        clearText();
    }*/
    if (e.shiftKey && e.altKey && e.keyCode == 40) {  // play or pause
        startOrPause();
    }
    /*if (e.ctrlKey && e.keyCode == 13) {  // ctrl + enter - clear text
        // call your function to do the thing
        toggleReadability();
    }*/
//todo: increase speed
}
// register the handler
document.addEventListener('keyup', doc_keyUp, false);

/*
left arrow	37
up arrow	38
right arrow	39
down arrow	40
enter       13
*/


/*function checkpurchasestatus(){
    if (skupurchased){
        premiumDisplay();
    }
    else {
         showpurchasedisplay();
    }
}*/


/*
function checkuserapprovalafterlogin(){
    if (UserApproveError == "The user did not approve access."||UserApproveError=="OAuth2 not granted or revoked."){
        hidepurchasedisplay();
    }
    else {
        console.log("we are in check user approval");
        showpurchasedisplay()};
};
*/

function hidepurchaseoverlay(){
    document.getElementsByClassName("purchase_screen_overlay")[0].style.display="none";
}

function showpurchasedisplay(){
    document.getElementsByClassName("purchase_screen_overlay")[0].style.display="inline";
}

function updateLanguage() {
    chrome.runtime.sendMessage({
        message_id: "update_language",
        language:select_language.value
    });
}

function updateSpeed() {
    chrome.runtime.sendMessage({
        message_id: "update_speed",
        speed:select_speed.value
    });
}

function retainText() {
    console.log("retainText");

    if (document.getElementById("text_box").value == wholeText) {
        return;
    }

    wholeText = document.getElementById("text_box").value;

    chrome.runtime.sendMessage({
        message_id: "update_text",
        text: wholeText,
        tab_id: tabId,
        Purl:document.URL
    });
}

function updateText() {
    chrome.runtime.sendMessage({
        message_id: "update_text",
        text:text_box.value,
        Purl:document.URL
    });
}

//The following function triggered when play/pause button is clicked, or Contextmenu button is clicked
function startOrPause() {
    //If isSpeaking=true, then it means that the reader is actually reading, then button should pause it.
   // console.log("The selected text is: " + Document.getSelection().toString());
    if (!isSpeaking) { //Play:
        play();
    } else {    //Pause:
        pause();
    }
}

function play() {
    updateLanguage(); //Make sure language is the correct one...
    updateSpeed();

    wholeText = document.getElementById("text_box").value;

    if (wholeText.length>0) {
        isSpeaking = true;

        //Make sure caret is at place not at end, in case caret was moved by user, when not playing, set it to user's choice:
        if (document.getElementById("text_box").selectionStart == wholeText.length) {
            setCaretPosition(0);
        } else {
            setCaretPosition(document.getElementById("text_box").selectionStart);
        }

        chrome.runtime.sendMessage({
            message_id: "start_speech",
            text: wholeText,
            caret: caretPos,
            tab_id: tabId
        });
        showUiPlaying();
    }
}

function pause() {
    isSpeaking = false;
    chrome.runtime.sendMessage({
        message_id: "pause_speech",
        tab_id: tabId
    });
    showUiPaused();
    //No need to move caret, as it never forwarded (it only forwards upon successful end)
}


/*function showUiRecording(){
    document.getElementById("record_button").style.backgroundImage = "url('images/stop_record_button.png')";

}
function showUiStopRecording(){
    document.getElementById("record_button").style.backgroundImage = "url('images/record_button50.png')";

}*/

function showUiPlaying() {
    isSpeaking = true;
    document.getElementById("speak_button").style.backgroundImage = "url('../images/pause_button.png')";
}

function showUiPaused() {
    isSpeaking = false;
    document.getElementById("speak_button").style.backgroundImage = "url('../images/start_button.png')";
}

function reloadText() {
    if (!bg) {
        return;
    }

    var query = {active: true, currentWindow: true};

    if (bg.getIsSpeaking()) {
        pause();
    }

    function callback(tabs) {
        tabId = tabs[0].id; // there will be only one in this array
        console.log(tabId); // also has methods like currentTab.id

        if (bg.getMasterId() == tabId) {
            chrome.runtime.sendMessage({
                message_id: "reset_master",
                tab_id: tabId
            });
        } else {}

        getPagesSource();
        /*chrome.tabs.executeScript(null, {   // todo: works only after implementing selection from contextmenu
            file: GET_PAGE_FILE
        }, function () {
            // If you try and inject into an extensions page or the webstore/NTP you'll get an error
            if (chrome.runtime.lastError) {
                message.innerText = 'There was an error injecting script : \n' + chrome.runtime.lastError.message;
            }
        });*/

        setCaretPosition(0);
        setSelectionRange(0, 0);
    }

    chrome.tabs.query(query, callback);
}

function toggleReadability() {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        chrome.storage.local.get('isPremium', function (result){
            //console.log("the value is " + result);
            console.log(result);
            console.log("The value of the Premium is: "+ result.isPremium);
            // debugger;
        chrome.tabs.sendMessage(tabs[0].id, {action: "toggleReadability",isPremium:result.isPremium}, function(response) {
            console.log(response);
            });
        });
    });
}

chrome.storage.local.get('isPremium', function (result){
    console.log("the value is " + result);
    console.log(result);
    // debugger;
    if (result.isPremium) {
        showpremiumScreen();
    }
    else{
        //document.getElementById("offlineMsg").style.display = "block";
        showNonPremiumScreen();

    }
});


function getPagesSource() {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, {action: "getPagesSource"}, function(response) {
            console.log(response);
        });
    });
}

function goToBeginning() {

    chrome.runtime.sendMessage({
       message_id: "go_to_beginning",
        text:wholeText,
       tab_id: tabId
    });

}

function setTextInTextBox(txt) {
    isUnderProgramaticChange = true;
    document.getElementById('text_box').value = txt;
}

/*
function setLicenseStatus(txt){
    LicenseStatusFromBackground = txt;
    console.log("we are in setlicense status and the status is: "+ txt);
}
*/

function clearText() {
    setTextInTextBox("");

    wholeText = "";
    caretPos = 0;
    chrome.runtime.sendMessage({
        message_id: "clear_text",
        text:   wholeText,
        caret: caretPos,
        tab_id: tabId
    });
}

function setSelectionRange(selectionStart, selectionEnd) {
    var input = document.getElementById("text_box");
 //   console.log(input);
 //   console.log(selectionStart + "; " + selectionEnd);
    if (input.setSelectionRange) {
        input.focus();
        input.setSelectionRange(selectionStart, selectionEnd);
    } else if (input.createTextRange) {
        var range = input.createTextRange();
        range.collapse(true);
        range.moveEnd('character', selectionEnd);
        range.moveStart('character', selectionStart);
        range.select();
    }
}

//To be called after updated caret position...
function setCaretPosition(pos) {
    caretPos = pos;
    setSelectionRange(pos, pos);

    scrollToViewCaret();
}

function scrollToViewCaret() {
    document.getElementById("text_box_mirror").value = wholeText.substring(0, caretPos);
    if (document.getElementById("text_box_mirror").scrollHeight > 341) {
        document.getElementById("text_box").scrollTop = document.getElementById("text_box_mirror").scrollHeight - 100;
    } else {
        document.getElementById("text_box").scrollTop = 0;
    }
}

if (!('speechSynthesis' in window)) {
    // Synthesis not supported.
    alert('Speech Synthesis is not supported by your browser. Switch to Chrome.');
}

function onWindowClose() {
    // wholeText = text_box.value;
    // console.log(wholeText)
    // updateText();
    //chrome.storage.local.set({'stored_text': wholeText}, function () {
        // Callback after save
   // });
}


function selectElement(elementId,valueToSelect) {
    var element = document.getElementById(elementId);
    element.value = getClosestValue(elementId, valueToSelect);
}

function getClosestValue(selectElementId, value) {
    var element = document.getElementById(selectElementId);
    var distance = null;
    var closestValue = null;
    for (var i=0; i<element.options.length; i++) {
        var iValue = element.options[i].value;
        if (iValue== value) {
            return value;
        } else {
            var d = Math.abs(element.options[i].value - value);
            if (distance==null) {
                distance = d;
                closestValue = iValue;
            } else if (d< distance) {
                distance = d;
                closestValue = iValue;
            }
        }
    }
    return closestValue;
}

function loadPreferences() {
    var storedLang = "";
    var storedRate = "";
    chrome.storage.local.get('stored_lang', function (result) {
      //  console.log(result);
        storedLang = result.stored_lang;
        if (storedLang) {
            //Set the UI according to previously stored settings:
            //$("#select_language option[value='" + storedLang + "']").attr('selected', true);
            selectElement("select_language",storedLang);
        }
    });

    chrome.storage.local.get('stored_rate', function (result) {
      //  console.log(result);
        storedRate = result.stored_rate;
        if (storedLang) {
            //Set the UI according to previously stored settings:
            //$("#select_speed option[value='" + storedRate + "']").attr('selected', true);
            selectElement("select_speed",storedRate);
        }
    });

    chrome.storage.local.get('stored_text', function (result) {
        //  console.log(result);
        //wholeText = result.stored_text;
        if (storedLang) {
            //Set the UI according to previously stored settings:
            //$("#select_speed option[value='" + storedRate + "']").attr('selected', true);
           // selectElement("select_speed",storedRate);
        }
    });
}


function onBgLoad(backgroundWindow) {
    bg = backgroundWindow;

    var voices = bg.getVoicesList();
    isfirstlaunch = 1;

    for (var i = 0; i < voices.length; i++) {
        select_language.options[i+1] = new Option(voices[i][1], voices[i][0]); // (text,value)
        //console.log(voices[i][1], voices[i][0]);
    }

    var query = {active: true, currentWindow: true};

    function callback(tabs) {
        tabId = tabs[0].id; // there will be only one in this array
        // console.log(tabId); // also has methods like currentTab.id

        //Am I the master? If not -> get page content. If yes - retrieve text from bg.
        var amIMaster = (bg.getMasterId() == tabId);
        console.log("am i master" + amIMaster);
        if (amIMaster || bg.getIsSpeaking()) {
            wholeText = bg.getText();
            setTextInTextBox(wholeText);
            setCaretPosition(bg.getCaretPosition());
            setSelectionRange(caretPos, wholeText.length - 1);  //TODO: Not working. Why?
        } else {
            getPagesSource();
            /*chrome.tabs.executeScript(null, {
                file: GET_PAGE_FILE
            }, function () {
                // If you try and inject into an extensions page or the webstore/NTP you'll get an error
                if (chrome.runtime.lastError) {
                    //message.innerText = 'There was an error injecting script : \n' + chrome.runtime.lastError.message;
                }
            });*/
        }

        if (bg.getIsSpeaking()) {
            showUiPlaying();
        } else {
            showUiPaused();
        }
    }

    chrome.tabs.query(query, callback);
    loadPreferences();

    /* chrome.app.window.create('index.html', {
            "id": "ManagedInAppPaymentsDemo",
            "bounds": {
                "width": 680,
                "height": 480
            },
            "minWidth": 650
        });*/

    hidepurchaseoverlay();

    chrome.runtime.onMessage.addListener(function (request, sender) {
        // console.log("i am in the listener of popup");
        var shouldRespondToBg = (bg.getMasterId() == tabId) || bg.getIsSpeaking();
        switch (request.message_id) {
            case "page_content":
                wholeText = request.source.toString();
                setTextInTextBox(wholeText);
                bg.wholeText = wholeText;
                /*chrome.runtime.sendMessage({
                    message_id: "set_newtext",
                    source: request.source.toString()
                });*/

                //If we wanted to show the html from Readability.js, we would send here article.content, and then:
                // var tempdiv = document.createElement('DIV');
                // tempdiv.innerHTML = request.source;
                // document.body.appendChild(tempdiv);

                break;
          /*  case "on_Purchase_Finished":
                console.log("we are in on purchase finished");
                getLicenses();
                break;*/
            case "set_selection_range":
                if (shouldRespondToBg) {
                    setSelectionRange(request.selection_start, request.selection_end);
                }
                break;
            case "speech_started_in_bg":
                //if (shouldRespondToBg) {
                showUiPlaying();
                isSpeaking = true;
                //}
                break;
            case "speech_paused_in_bg":
                //if (shouldRespondToBg) {
                showUiPaused();
                isSpeaking = false;
                //}
                break;
            case "set_caret_position":
                if (shouldRespondToBg) {
                    setCaretPosition(request.data);
                }
                break;
            case "reloadText":
                reloadText();
                break;
            case "goToBeginning":
                goToBeginning();
                break;
            case "clearText":
                clearText();
                break;
            case "startOrPause":
                startOrPause();
                break;
            case "toggleReadability":
                toggleReadability();
                break;
        }
    });
};


window.onunload = onWindowClose;



